local function cclog(...)
    print(string.format(...))
end

--[[
	base: 			the base value
	npc: 			the same series npc change value
	enemy:			the enemy change value
	hp:				the hp change value
	towerHP:		the tower hp change value
	attack:			the attack change value
	skillPoint:		the use skill value
]]


enemySkillProbability = {
["10001"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10002"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10003"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10004"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10005"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10006"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10007"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10008"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10009"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10010"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["10011"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11001"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11002"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11003"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11004"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11005"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11006"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11007"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11008"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["11009"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12001"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12002"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12003"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12004"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12005"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12006"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["12007"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["13001"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["13002"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	10	,	towerHP = 	20	,	attack = 	3	,	skillPoint = 	100	},
["19001"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	0	,	towerHP = 	20	,	attack = 	1	,	skillPoint = 	500	},
["19002"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	0	,	towerHP = 	20	,	attack = 	1	,	skillPoint = 	500	},
["19003"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	0	,	towerHP = 	20	,	attack = 	1	,	skillPoint = 	500	},
["19004"]	 = {	base = 	0	,	npc = 	2	,	enemy = 	3	,	hp = 	0	,	towerHP = 	20	,	attack = 	1	,	skillPoint = 	500	},


}

local tData = {};

--get a skill data table by npc id
function getEnemyUseSkillDataTable ( id )
	local t = enemySkillProbability[tostring(id)];
	return t
end

--get enemy attack delta value
function getEnemyAttackDeltaData ( id )
	local t = enemySkillProbability[tostring(id)];
	local n = t.attack;
	return n;
end

--get the same series npc probability
function getSameNPCProbability ( npcCount )
	local rp = npcCount * tData.npc;
	return rp;
end

--get the enemy count probability
function getEnemyCountProbability ( enemyCount )
	local rp = enemyCount * tData.enemy;
	return rp;
end

--get the hp change probability
function getHPProbability ( maxHP, curHP )
	--local rp = (maxHP - curHP) / maxHP * tData.hp;
  local rp = (1-(maxHP - curHP) / maxHP) * tData.hp;
	return rp;
end

--get the tower hp change probability
function getTowerHPProbability ( towerMaxHP, towerCurHP )
	local rp = (1-(towerMaxHP - towerCurHP) / towerMaxHP) * tData.towerHP;
	return rp;
end

--get the sum probability
function getUseSkillSumProbability ( npcCount, enemyCount, maxHP, curHP, towerMaxHP, towerCurHP )
	local sumRP = tData.base + getSameNPCProbability(npcCount) + getEnemyCountProbability(enemyCount) + getHPProbability(maxHP, curHP) + getTowerHPProbability(towerMaxHP, towerCurHP);
	return sumRP;
end

--[[function enemyUseSkill ( character, npcCount, enemyCount, maxHP, curHP, towerMaxHP, towerCurHP )
	tData = getEnemyUseSkillDataTable( character:getNPCID() );
	math.randomseed(tostring(os.time()):reverse():sub(1, 6));
	local randNum = math.random(10000);
	local sumRP = math.ceil(getUseSkillSumProbability( npcCount, enemyCount, maxHP, curHP, towerMaxHP, towerCurHP ));
	cclog("NPCID: " .. character:getNPCID() .. "   " .. "skill random number: " .. randNum .. "   " .. "skill sum RP: " .. sumRP);
	if randNum <= sumRP then
		if character:getCharacterState() ~= CHARACTER_STATE_USE_SKILL then
			cclog("NPCID: " .. character:getNPCID() .. "   " .. "Use Skill!!!")
			return true;
		end
	end

	return false;
end]]

--[[
	npcID:				the current npc id
	npcCount:			the same series npc count
	enemyCount:			the enemy count
	maxHP:				the character max hp
	curHP:				the character current hp
	towerMaxHP:			the tower max hp
	towerCurHP:			the tower current hp
	attackCount			the attack count
]]
function enemyUseSkill ( npcID, npcCount, enemyCount, maxHP, curHP, towerMaxHP, towerCurHP, attackCount )
	tData = getEnemyUseSkillDataTable( npcID );
	local sumRP = math.ceil(getUseSkillSumProbability( npcCount, enemyCount, maxHP, curHP, towerMaxHP, towerCurHP ));
	local sumCount = attackCount + sumRP;
	--cclog("NPCID: " .. npcID .. "   " .. "attackCount: " .. attackCount .. "   " .. "skill number: " .. sumCount);
	--[[cclog("base: " .. tData.base);
	cclog("npc: " .. tData.npc);
	cclog("enemy: " .. tData.enemy);
	cclog("hp: " .. tData.hp);
	cclog("towerHP: " .. tData.towerHP);
	cclog("attack: " .. tData.attack);
	cclog("skillPoint: " .. tData.skillPoint);]]
	if tData.skillPoint  <= sumCount then
		--cclog("NPCID: " .. npcID .. "   " .. "Use Skill!!!")
		return true;
	end

	return false;
end