local function cclog(...)
    print(string.format(...))
end

function addSprite(e)
    -- 获取屏幕宽高
    screenSize=CCDirector:sharedDirector():getWinSize()

    myLableTTF2 = CCLabelTTF:create("Lua输出的字符串哦啦啦","Helvetica-Bold",24)
    myLableTTF2:setPosition(CCPoint(screenSize.width*0.5,screenSize.height*0.5-100))
    e:addChild(myLableTTF2)
    
    cclog("addSprite executed")
    
    return true,12,"fuck"
end

function getAttackDamage(AttackerAtk, AttackerLv, AttackerRank, TargetDef, TargetRank)
    return AttackerAtk*(1-TargetDef/(TargetDef+100*AttackerLv))
end

function getSkillDamage( Coefficient,AttackerAtk, AttackerLv, AttackerRank, TargetDef, TargetRank )
    return Coefficient*(AttackerAtk*(1-TargetDef/(TargetDef+100*AttackerLv)))
end

function getUnitFinalHp(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return (Basic+(Ratio+Star/100)*Lv+EquipValue)*AccessoryValue
end

function getUnitFinalHpRatio(Ratio, Star)
  return Ratio*(1+Star/100)
  end

function getUnitFinalAtk(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return (Basic+(Ratio+Star/100)*Lv+EquipValue)*AccessoryValue
end

function getUnitFinalAtkRatio(Ratio, Star)
  return Ratio*(1+Star/100)
end

function getUnitFinalDef(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return (Basic+(Ratio+Star/100)*Lv+EquipValue)*AccessoryValue
end

function getUnitFinalDefRatio(Ratio, Star)
  return Ratio*(1+Star/100)
end

function getUnitFinalAtkRate(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return Basic
end

function getUnitFinalSpeed(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return Basic
end

function getUnitFinalCD(Basic, Ratio, Rank, Star, Lv, EquipValue, AccessoryValue)
    return Basic
end

function getUnitCombat(HP, Atk, Def, AtkRate, Move)   --战斗力
    return math.floor(HP*0.625+Atk+Def)
end

function getEquipFinalHp(Basic, Ratio, Rank, Star, Lv)
    return Basic+(Ratio*(1+Star/100))*(Lv-1)
end

function getEquipFinalAtk(Basic, Ratio, Rank, Star, Lv)
    return Basic+(Ratio*(1+Star/100))*(Lv-1)
end

function getEquipFinalAtkRatio(Ratio, Star)
  return Ratio*(1+Star/100)
end

function getEquipFinalDefRatio(Ratio, Star)
  return Ratio*(1+Star/100)
  end

function getEquipFinalDef(Basic, Ratio, Rank, Star, Lv)    
    return Basic+(Ratio*(1+Star/100))*(Lv-1)
end

function getAccessoryFinalHpRatio(Ratio, Star)
  return Ratio*(1+Star/100)
end

function getEquipUpgradeCost(Rank, Star, Lv)           --装备升级消耗
  if Rank==1 then
    return math.floor(100*1.12^(Lv-1)*(1+Star/100))
    
  elseif Rank==2 then
    return math.floor(300*1.12^(Lv-1)*(1+Star/100))
    
  elseif Rank==3 then
    return math.floor(500*1.12^(Lv-1)*(1+Star/100))
    
  elseif Rank==4 then
    return math.floor(800*1.12^(Lv-1)*(1+Star/100))
    
  elseif Rank==5 then
    return math.floor(1200*1.12^(Lv-1)*(1+Star/100))
  
  else return 100000
  end
end

function getAccessoryUpgradeCost(Basic, Ratio, Rank, Star, Lv)   --饰品升级消耗
  if Rank==1 then
    return math.floor(1000*1.5^(Lv-1)*(1+Star/100))
    
  elseif Rank==2 then
    return math.floor(3000*1.5^(Lv-1)*(1+Star/100))
    
  elseif Rank==3 then
    return math.floor(5000*1.5^(Lv-1)*(1+Star/100))
    
  elseif Rank==4 then
    return math.floor(8000*1.5^(Lv-1)*(1+Star/100))
    
  elseif Rank==5 then
    return math.floor(10000*1.5^(Lv-1)*(1+Star/100))
  
  else return 1000000
  end
end

function getUnitUpgradeExp(CurLv, Rank, Star)       --宠物升级经验
    if Rank==1 then
      return math.floor((0.8*CurLv^2+24.2)*(1+Star/100))
    elseif Rank==2 then
      return math.floor((0.8*CurLv^2+24.2)*1.5*(1+Star/100))
    elseif Rank==3 then
      return math.floor((0.8*CurLv^2+24.2)*2.25*(1+Star/100))
    elseif Rank==4 then
      return math.floor((0.8*CurLv^2+24.2)*3.4*(1+Star/100))
    elseif Rank==5 then
      return math.floor((0.8*CurLv^2+24.2)*4.5*(1+Star/100))      
    else return 100000
      end
end

function getUnitDropExp(Lv, Rank, Star)         --宠物掉落经验
    if Rank==1 then
      return math.floor((0.8*Lv^2+24.2)*0.1*(1+Star/100))
    elseif Rank==2 then
      return math.floor((0.8*Lv^2+24.2)*1.5*0.1*(1+Star/100))
    elseif Rank==3 then
      return math.floor((0.8*Lv^2+24.2)*2.25*0.1*(1+Star/100))
    elseif Rank==4 then
      return math.floor((0.8*Lv^2+24.2)*3.4*0.1*(1+Star/100))
    elseif Rank==5 then
      return math.floor((0.8*Lv^2+24.2)*4.5*0.1*(1+Star/100))      
    else return 100000
      end
end

function getRank(SumRatio)
    if SumRatio < 10  then
        return 1
    elseif SumRatio < 20 and SumRatio >=10 then
        return 2
    elseif SumRatio < 39 and SumRatio >= 20 then
        return 3
    elseif SumRatio < 65 and SumRatio >= 40 then
        return 4
    elseif SumRatio < 90 and SumRatio >= 65 then
        return 5
    elseif SumRatio < 120 and SumRatio >= 90 then
        return 6
    else return 7
    end
end

function getSumRatio( HpRatio,AtkRatio,DefRatio,Star )
  return ( HpRatio*0.3+AtkRatio+DefRatio)*(1+Star/100)
 end

function getEquipRatio( AtkRatio,DefRatio,Star )
  return ( AtkRatio+DefRatio)*(1+Star/100)*10
 end

function getAccessoryRatio( HpRatio,AtkRatio,DefRatio,Star )
  return ( HpRatio+AtkRatio+DefRatio)*(1+Star/100)*100
 end

function getEquipRank(SumRatio)
    if SumRatio < 40 then
        return 1
    elseif SumRatio < 80 and SumRatio >= 40 then
        return 2
    elseif SumRatio < 120 and SumRatio >= 80 then
        return 3
    elseif SumRatio < 160 and SumRatio >= 120 then
        return 4
    else return 5
    end
end

function getAccessoryRank(SumRatio)
    if SumRatio < 1.5 then
        return 1
    elseif SumRatio < 2 and SumRatio >= 1.5 then
        return 2
    elseif SumRatio < 2.5 and SumRatio >= 2 then
        return 3
    elseif SumRatio < 3 and SumRatio >= 2.5 then
        return 4
    else return 5
    end
end

function getRageValue ( maxHP )
    return (maxHP * 2 * 0.01)
end

function getPvgCdCash ( RestCd )
    if RestCd <= 600 and RestCd > 480 then
      return 5
     elseif RestCd <= 480 and RestCd > 360 then
      return 4
     elseif RestCd <= 360 and RestCd > 240 then
      return 3
     elseif RestCd <= 240 and RestCd > 120 then
      return 2
     elseif RestCd <= 120 and RestCd > 0 then
      return 1
     end
end

function getComposeCdCash ( ComposeCd )
    if Compose <= 3600 and Compose > 3000 then
      return 50
     elseif Compose <= 3000 and Compose > 2400 then
      return 40
     elseif Compose <= 2400 and Compose > 1800 then
      return 30
     elseif Compose <= 1800 and Compose > 1200 then
      return 20
     elseif Compose <= 1200 and Compose > 0 then
      return 10
     end
end
    
function getCallNPCMaxHP(hp)
  return hp*1.3
end

function getCallNPCAttack(atk)
  return atk*0.6
end

function getCallNPCDefense(def)
  return def*1.2
end

function getCallNPCSpeed(Speed)
  return Speed*1.2
end

function getCallNPCAttackRate(atkRate)
  return atkRate*0.8
end 

function getCallNPCAttackCount(atkCount)
  return atkCount
end 

function getClearChallengeBossCDCost( bossCD )
  return 10
end
    
function getPlayerBattleLoseCoin( playerCoin )
  return math.floor(playerCoin*0.05)
end

function getPetEvolutionStar(pet1Star,pet2Star,Pet1Rank,Pet2Rank)  -- 宠物进化后星级 
  --pet1Star 主宠物原来星级 类推
  --pet1Rank 主宠物原来品质 类推
  return pet1Star + Pet2Rank + pet2Star*1.5^(Pet2Rank - Pet1Rank)
 end

function getEquipEvolutionStar(equip1Star,equip2Star,equip1Rank,equip2Rank)  -- 装备进化后星级 
  --equip1Star 主装备原来星级 类推
  --equip1Rank 主装备原来品质 类推
  return equip1Star + equip2Rank + equip2Star*1.5^(equip2Rank - equip1Rank)
 end

function getpetMaterialCount(Rank,EvolutionStar)    -- 宠物进化所需材料数 
  --EvoludtionStar 进化后的星级
  --Rank主宠品质

  return math.floor(1.667*Rank^2+3.333+math.floor(EvolutionStar/10)*5)
 end

function getEquipMaterialCount(Rank,EvolutionStar)    -- 装备进化所需材料数 
  --EvoludtionStar 进化后的星级
  --Rank主装备品质
  return math.floor(1.667*Rank^2+3.333+math.floor(EvolutionStar/10)*5)
 end

 function getTeamGridOpenLevel ( index )              -- 宠物队列开发格子
  if index == 0 then
    return 0;
  elseif index == 1 then
    return 0;
  elseif index == 2 then
    return 0;
  elseif index == 3 then
    return 10;
  elseif index == 4 then
    return 30;
  elseif index == 5 then
    return 80;
  else
    return 0;
  end
 end